<?php
namespace Teknisa\CADSUP\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;

class ger07100Controller {

     public function __construct($service) {
        $this->service = $service;
    }

	public function insertFornecedor(DTO\Request $request, DTO\Response $response) {
		try {
            $row = $request->getRow();
            
            $fornecedor = $this->service->getFornecedor($row);
            $nomeTipoFornecedor = $this->service->verificaNome($row);
            
            if ($fornecedor){
            	throw new \Exception("Código já cadastrado.");	
            } else if ($nomeTipoFornecedor){
            	throw new \Exception("Nome já cadastrado.");	
            }
            
			$this->service->insertFornecedor($row);
			
			$response->addMessage(new Message("Salvo com sucesso."));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function updateFornecedor(DTO\Request $request, DTO\Response $response) {
		try {
            $row = $request->getRow();
            
            $nomeTipoFornecedor = $this->service->verificaNome($row);
            
            if ($nomeTipoFornecedor){
            	throw new \Exception("Nome já cadastrado.");	
            }
            
			$this->service->updateFornecedor($row);
			
			$response->addMessage(new Message("Salvo com sucesso."));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function deleteFornecedor(DTO\Request $request, DTO\Response $response) {
		try {
            $row = $request->getRow();
            
			$this->service->deleteFornecedor($row);
			
			$response->addMessage(new Message("Salvo com sucesso."));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
}