<?php

namespace Teknisa\CADSUP\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class MensagensEnvioEmailService {
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function addMensageEnvEmail ($row){
        
		$param = array(
		    'P_DSSUBJECT' => $row['DSSUBJECT'],
		    'P_DSBODY' => $row['DSBODY'],
		    'P_IDOPERACAO' => $row['IDOPERACAO'],
		    'P_NRORG' => $this->environment->getNrorg(),
		    'P_IDATIVO' => 'S',
		);
		
        $query = "INSERT INTO MENSAGEMPADRAOEMAIL (DSSUBJECT,DSBODY,IDOPERACAO, NRORG, IDATIVO, DTINCLUSAO)  
        VALUES (:P_DSSUBJECT,:P_DSBODY,:P_IDOPERACAO,:P_NRORG,:P_IDATIVO, SYSDATE)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
        public function deleteMensageEnvEmail ($row){
        
		$param = array(

		    'P_IDOPERACAO' => $row['IDOPERACAO'],
		    'P_NRORG' => $this->environment->getNrorg()

		);
		
        $query = "DELETE FROM MENSAGEMPADRAOEMAIL
               WHERE IDOPERACAO = :P_IDOPERACAO
                AND NRORG = :P_NRORG";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateMensageEnvEmail ($row){
        
		$param = array(
		    'P_DSSUBJECT' => $row['DSSUBJECT'],
		    'P_DSBODY' => $row['DSBODY'],
		    'P_IDOPERACAO' => $row['IDOPERACAO'],
		    'P_NRORG' => $this->environment->getNrorg()

		);
		
        $query = "UPDATE MENSAGEMPADRAOEMAIL
                    SET DSSUBJECT = :P_DSSUBJECT,
                        DSBODY = :P_DSBODY
                        
                    WHERE IDOPERACAO = :P_IDOPERACAO
                        AND NRORG = :P_NRORG";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            return var_dump($std->fetchAll());
        } catch (Exception $e){
            throw $e;
        }
    }

}